#!/usr/bin/env python3

# -*- coding: utf-8 -*-
'''
**********************************************************

PiStream Radio
Internet steaming Radio

Mark Mokoski
Robert James Indistries LLC
www.rjillc.com

App Ver A.0.1
26-AUG-2016
First code as test

App Ver A.0.2
01-SEP-2016
Flesh out code with controls

App Ver A.0.3
03-SEP-2016
Most GUI elements working, 'sleep timer' last to complete

App Ver A.0.4
04-SEP-2016
GUI done, sleep timer complete.
Next GUI release will be production version 1.0.x

App Ver 1.0.5
05-SEP-2016
A few GUI posistion cleanup's
Production relaese

App Ver 1.0.6
28-SEP-2016
Add volume slider update and Mute update from commandline ( MPC)

App Ver 1.0.7
01-OCT-2016
Made some font and position adjustments for the new RPi PIXEL Desktop

App Ver 1.0.8
15-FEB-2017
Set PREV and NEXT functions to 'wrap around' when you get the to tthe
start or end of stored (playlist) stations
Added "x/y" to playing prompt to note ststion number and total stions in playlist
ex: PLAYING 2/17

App Ver 1.0.9
16-FEB-2017
Add keyboard control of player.
<ESC> = end exir program
Multimedia keyboard keys to start/stop play, change volume, mute, next/prev program selection.
up/down arrow keys change station selectio
left/right arrow keys change volume

App Ver 1.0.10
28-FEB-2017
Fixed errors on first time run.
Station Name (ID) and Program tiltle set to default
'NO STATION ID', 'NO PRORGRAM INFORMATION'
This fixed first time error from MPD as these fields
where NULL until MPD recieved info from stream

App Ver 1.0.11
03-MAY-2017
If Sleep Timer activated, check for playing station.
Else, play current station and start Sleep Timer.

App Ver 1.0.12
21-JUL-2017
If network connection lost, force 'STOP PLAY'.
Also,keyboard and IR remote key press enhancements.

**********************************************************
'''

'''
**********************************************************
*
* Start of Python Script
*
**********************************************************
'''

import os
import time
import socket
import subprocess
import pickle
import _thread as thread
import RPi.GPIO as GPIO
from datetime import datetime
from mpd import MPDClient
from tkinter import *
from select import select

'''
**********************************************************
*
Setup GPIO used by GUI
*
**********************************************************
'''
# GPIO future feature for amp on/off control
# GPIO for rotary encoders for volume and station select
# GPIO for 'soft' power switch and station menu
'''
**********************************************************
*
* define some of the GUI setup and global var's
*
**********************************************************
'''
app_path="~/PiStream_Radio/" #static path on current release
app_ver="1.0.12"
win = Tk() # win widget for the GUI
client = MPDClient()
client.connect("localhost", 6600)

station_text = StringVar()
program_text = StringVar()
local_time = StringVar()
UTC_time = StringVar()
state_text = StringVar()
slider_vol = IntVar()
count_down = StringVar()
IP_status = StringVar

volume = 50
mute_volume = 50
mute = 'false'
playlist_lenght = "0"
song_number = "0"
playstate = 'STOPPED'
count_down.set('00:00')
network_status=""
sleep_set='false'
countdown=60 #sleep timer start in minutes
mute_img=PhotoImage(file="Mute.png")
unmute_img=PhotoImage(file="UnMute.png")

'''
**********************************************************
*
* function definitions
*
**********************************************************
'''
def disp_time():
   
   #display time in window

   global local_time
   global UTC_time
     
   #get and sisplay current time on local 12hr and UTC
   local_time.set((datetime.now().strftime('%b %d %Y - %I:%M %p')))
   UTC_time.set((datetime.utcnow().strftime('%b %d %Y - %H:%M ')))

   #next update 1000 ms
   win.after(1000, disp_time)

   
def update_all_now():

   global station_text
   global program_text
   global network_status
   global win
   global volume
   global playlist_lenght
   global playstate
   global network_status
   global IP_status
   global mute_volume
   
   #get any info from mpc and update
   cs = client.currentsong()

   # Get any proram info from stream
   if 'title' in cs:
     SongTitle = cs['title']
   else:
     SongTitle = "No Program Information"

   # if stream has not updated station name, defaut to 'No Station Name'         
   if 'name' in cs:
         if cs['name'] == "":
            station_name = "No Station Name"

         else:
            station_name = cs['name']

            station_text.set(cs['name'])
            program_text.set(SongTitle)
   else:
      station_text.set("No Station ID")
      program_text.set(SongTitle)
       
   try:
     print ('Current Player Status: as of ' + (datetime.now().strftime('%Y %b %d  %H:%M:%S ')) + " Local")
     print ('                             ' + (datetime.utcnow().strftime('%Y %b %d  %H:%M:%S ')) + " UTC")
     print ('Station     : ' + station_name)
     station_text.set(station_name)
     print ('Now Playing : ' + SongTitle)
     
     program_text.set(SongTitle)
     cs = client.status()
     mpc_vol = cs['volume']
     
     # if volume changed from commandline
     if mute == 'true':
        if int(mpc_vol) > 0:
           mute_volume = mpc_vol
           click_mute()
           s_volume.set(volume)   # set slider to reflect current play volume
       
     if mute == 'false':
        if int(mpc_vol) == 0:
           click_mute()
        elif mute == 'false':
           volume = mpc_vol
           s_volume.set(volume)   # set slider to reflect current play volume
     
     
     print ('Volume      : ' + volume + '%')
     playlist_lenght = cs['playlistlength']
     print ('Playlist Lenght = ' + playlist_lenght)
     song_num = str(int(cs['song'])+1)
     print ('Song Number = ' + song_num)
     #split out the audio prarameters into a 'list', parse list for individual items
     audio_prams = cs['audio'].split(':')
      
     if cs['state'] == 'play':
       playstate = 'PLAYING'
       l_playstate.config(fg='green2')
       last_song = int(playlist_lenght)   
       cs = client.status()
       song_num = (int(cs['song'])+1)
       state_text.set('PLAYING '+str(song_num)+"/"+str(last_song))

       
     elif cs['state'] == 'pause':
       playstate = 'PAUSED'
       l_playstate.config(fg='gold')
       state_text.set('PAUSED')
       
 
     print ('Player Status is: ' + playstate + ' ' + audio_prams[1] + ' Bit Audio @ ' + audio_prams[0] + ' Hz Sampling, ' + audio_prams[2] + ' Channels')
     print ( 'Current Stream Bitrate is ' + cs['bitrate'] + ' Kbps')
     
   except:
    print ('**** MPC player Stopped ****')
    playstate = "STOPPED"
    l_playstate.config(fg='red')
    state_text.set('STOPPED')
     
   #get local host name and local IP address

   if inet_connected() == True: 
      s = socket.create_connection(("www.google.com", 80),1)
      IPaddr = s.getsockname()[0]
      s.close()
      print (os.uname()[1] + " is Connected to Network - local IP address:  " + IPaddr + "\n")
      win.title("PiStream Radio : Ver "+ app_ver + "  -  Connected to Network - Local IP Address:  " + IPaddr) #put network status in window title
      IP_state = ('Network Status - ' + os.uname()[1] + " Connected to Network \n Local IP Address:  " + IPaddr)
      
   else:
    network_status = (" ** local IP address ERROR - No Nnetwork Connection **")
    print (os.uname()[1] + "  - Player is " + playstate + " - Local IP Address ERROR - No Network Connection \n")
    win.title("PiStream Radio : Ver "+ app_ver + ' - ' + ' - Local IP Address ERROR - No Nnetwork Connectionnetwork_status') #put network status in window title
    IP_state = ('Network Status - ' + os.uname()[1] +' Local IP Address ERROR \n No Network Connection')
    click_stop()
    
   #Write to window IP_status.set([IP_state])
   l_network_status.config(text = IP_state)
   #update every 10 Sec
   win.after(10000, update_all_now)

def inet_connected(): # Test Internet connection
   
   REMOTE_SERVER = "www.google.com"
   try:
      host = socket.gethostbyname(REMOTE_SERVER)
      s = socket.create_connection((host, 80), 2)
      s.close()
      return True
   
   except:
      pass
      return False
      
def update_play():

   click_play()
   
   #get any info from mpc and update
   cs = client.currentsong()
   #print (cs)
   if 'title' in cs:
     SongTitle = cs['title']
   elif 'file' in cs:
     SongTitle = "No Program Information"
     
   if 'name' in cs:
      station_text.set(cs['name'])
      program_text.set(SongTitle)
   else:
      station_text.set("No Station ID")
      program_text.set(SongTitle)
      
   last_song = int(playlist_lenght)   
   cs = client.status()
   song_num = (int(cs['song'])+1)
   l_playstate.config(fg='green2')
   state_text.set('PLAYING '+str(song_num)+"/"+str(last_song))
 
      
def click_mute():
   #mute the audio, save currnt volume level for unmute

   global volume
   global mute_volume
   global mute

   if mute == 'false':
      mute_volume = volume   #save current volume before mute
      client.setvol(0)
      cs = client.status()
      volume = cs['volume']
      mute = 'true'
      b_mute.config(text = 'UNMUTE')
      img = PhotoImage(file="UnMute.png")
      b_mute.config(image = unmute_img)

   else:
      volume = mute_volume   #restore volume to level before mute
      client.setvol(volume)
      cs = client.status()
      volume = cs['volume']
      mute = 'false'
      b_mute.config(text = 'MUTE')
      b_mute.config(image = mute_img)
        
   
def click_exit():
   #stop plying and exit program
  
   client.stop() #stop playing
   '''
   if mute == 'true':
      volume = mute_volume   #restore volume to level before mute
      client.setvol(volume)
      time.sleep(5)
      '''
   win.destroy() #close the window
   sys.exit()    #exit the scrip 'main loop' (treminate)
   
   
   
   
def click_next():
   #play the next station in the playlist
   
   cs = client.status()
   song_num = int(cs['song'])
   
   if song_num + 1 < int(playlist_lenght): #check for last song in playlist
      client.playid(int(cs['song'])+2)
      update_play() # auto play if 'STOPPED'

   else: # reached end of playlist, 'wrap around' to first playlist entry
      client.playid(1) # play first entry in playlist
      update_play() # auto play if 'STOPPED'
   
def click_prev():
   #play previous station in the playlist

   last_song = int(playlist_lenght)
   
   cs = client.status()
   song_num = (int(cs['song'])+1)
   
   if song_num <= 1: # reached begining of playlist, 'wrap around' to last playlist entry
      client.playid(int(playlist_lenght))
      update_play() # auto play if 'STOPPED'

   else: 
      client.playid(int(cs['song']))
      update_play() # auto play if 'STOPPED'

def click_play():
   global playstate

   client.play()
   playstate = 'PLAYING'
   l_playstate.config(fg='green2')
   
   last_song = int(playlist_lenght)
   
   cs = client.status()
   song_num = (int(cs['song'])+1)
   '''   
   client.play()
   playstate = 'PLAYING'
   l_playstate.config(fg='green2')
   '''
   state_text.set('PLAYING '+str(song_num)+"/"+str(last_song))

def click_pause():
   global playstate
      
   if playstate == 'PLAYING':
      client.pause()
      playstate = 'PAUSED'
      l_playstate.config(fg='gold')
      state_text.set('PAUSED')
   elif playstate == 'PAUSED':
      client.play()
      playstate = 'PLAYING'
      l_playstate.config(fg='green2')
      state_text.set('PLAYING')
      
def click_stop():
   global playstate
   
   client.stop()
   playstate = 'STOPPED'
   l_playstate.config(fg='red')
   state_text.set('STOPPED')

def get_stored_vol(): #on start, get last volume of MPD
   global volume

   cs = client.status()
   volume = cs['volume']
   slider_vol.set(int(volume))
   client.setvol(volume)
   
def change_vol(v): #change MPD volume from the Scale (slider)
   global volume
   global mute_volume
   
   volume = str(v)
   client.setvol(v)

   if mute == 'true':
        mute_volume = volume
        click_mute()
        
   s_volume.set(volume)
   
def screen_sleep(): #force screen into 'sleep' mode (blank display)
   subprocess.call("export DISPLAY=:0 &&xset dpms force off", shell=True)

def sleep_timer():
   global countdown
   global sleep_set

   if sleep_set == 'false': #set sleep timer
      countdown=59
      sleep_set = 'true'
      l_timer_countdown.config(fg='gold')
      l_timer_static.config(fg='gold')
      timer_print='00:'+ str(countdown)
      count_down.set(timer_print)
      win.after(60000, sleep_count) #set polling every 60 seconds

      if playstate == 'STOPPED':
         click_play() #if player stopped, play the current station
            
   else: #abort sleep timer
      sleep_set = 'false'
      count_down.set('00:00')
      l_timer_countdown.config(fg='snow3')
      l_timer_static.config(fg='snow3')
   
def sleep_count():
   global countdown
   global sleep_set
   
   if sleep_set =='true':
      countdown= countdown -1
      timer_print='00:'+ str(format(countdown, '02d'))
      count_down.set(timer_print)
      win.after(60000, sleep_count) #set polling every 60 seconds
      if timer_print == '00:00':
         sleep_set='false'
         count_down.set('00:00')
         l_timer_countdown.config(fg='snow3')
         l_timer_static.config(fg='snow3')
         click_stop() #stop the player
         screen_sleep() #put screen in sleep mode
         
   elif sleep_set =='false':
      return
   

def key(event):   # tkinter key press event.  translate keyboard and multimedia keys to fuctions

   global slider_vol
   
   #print ("Keyname pressed", event.keysym)
   
   if event.keysym == "Escape": # 'EXIT' program
      click_exit()

   elif event.keysym == "XF86AudioNext" or event.keysym == "XF86AudioForward" or event.keysym == "Right": # 'NEXT' station
      click_next()
      
   elif event.keysym == "XF86AudioPrev" or event.keysym == "XF86AudioRewind" or event.keysym == "Left": # 'PREV' station
      click_prev()

   elif event.keysym == "XF86AudioPlay": # PLAY / STOP toggle 
         if playstate == 'STOPPED':
            click_play()
         elif playstate == 'PAUSED': #restore PLAY mode if PAUSED and play button pressed
         	click_play()         
         else:
            click_stop()
            
   elif event.keysym == "XF86AudioMute": #MUTE audio toggle
      click_mute()
      
   elif event.keysym == "XF86AudioLowerVolume" or event.keysym == "Down" or event.keysym == "minus": # lower volume
         if mute == 'true': #UNMUTE when in mute state and volume key pressed
      	    click_mute()
         else:
            v = (int(volume) -1)
            change_vol(v)

   elif event.keysym == "XF86AudioRaiseVolume" or event.keysym == "Up" or event.keysym == "equal": # raise volume
         if mute == 'true': #UNMUTE when in mute state and volume key pressed
      	    click_mute()
         else:
            v = (int(volume) +1)
            change_vol(v)
           
   elif event.keysym == "F1": # Blank display (turn off backlight)
      screen_sleep()
    
   elif event.keysym == "F2": # Start/Stop Sleep Timer
      sleep_timer()
    
'''
*********************************************************
*
* Sart up the GUI
*
*********************************************************
'''
print("\n*** PiStream Radio **\n") #to ID terminal window

win.geometry('800x480')
win.configure(bg='black') #make the app 'theame noir' (black)

#setup the GUI elements, frames, labels, text boxes, buttons etc.

#logo picture
img=PhotoImage(file="radio-modern-medium.png")

#put logo picture in label
l_logo = Label(win,image=img,bg='black')
l_logo.place(x=40, y=0)

'''
#'frame in' the time(s)
f_time = Frame(win, width=300, height=100,bg='black',relief='ridge',borderwidth=4)
f_time.place(x=495,y=5)
'''
'''
#'divider' frame inbetween time formats
f_time_div=Frame(win,width=280,height=7,bg='black',relief='raised',borderwidth=4)
f_time_div.place(x=505,y=50)
'''
#'frame in' station and program data
f_program = Frame(win, width=790, height=80,bg='black',relief='ridge',borderwidth=4)
f_program.place(x=5,y=260)

#title on the window
l_title=Label(win,text='PiStream Radio',justify='center',
              font=('Fixedsys',20,'bold'),bg='black',fg='green')
l_title.place(x=267,y=15)

#slogan on the window
l_slogan=Label(win,text='Internet Streaming Audio Player',justify='center',
               font=('Arial',12,'bold'),bg='black',fg='green')
l_slogan.place(x=240,y=50)

#App Ver on the window
l_slogan=Label(win,text='App Ver - '+ app_ver,justify='center',
font=('Arial',10),bg='black',fg='green')
l_slogan.place(x=338,y=70)

#local time label (12 hr format AM/PM)
l_time_local= Label(win, text="Local Time: ", justify='left',
                    font=('Courier',12, 'bold'),bg='black', fg='snow3')
l_time_local.place(x=550, y=5)

#local time / date AM/PM format
t_time_local = Label(win, textvariable = local_time, justify='left',
                     font=('Courier',14, 'bold'), bg='black', fg='gold')
t_time_local.place(x=550, y=25)

#UTC time label
l_time_UTC= Label(win, text="UTC Time: ", justify='left',
                  font=('Courier',12, 'bold'),bg='black', fg='snow3')
l_time_UTC.place( x=550, y=50)

#UTC time / date 24hr format
t_time_UTC = Label(win, textvariable = UTC_time, justify='left',
                   font=('Courier',14, 'bold'), bg='black', fg='gold')
t_time_UTC.place(x=550, y=70)

#current station label
l_station = Label(win, text=" Station - ", justify='left',
                  font=('Courier',11, 'bold'), bg='black', fg='gold')
l_station.place(x=10, y=270)

#current station playing
t_station_text = Label(win, textvariable = station_text, justify='left',
                       font=('Courier',16, 'bold'), bg='black', fg='red')
t_station_text.place(x=105, y=270)

#program label
l_program = Label(win, text=" Program - ", justify='left',
                  font=('Courier',11, 'bold'), bg='black', fg='gold')
l_program.place(x=10, y=300)

#current program playing
t_program_text = Label(win, textvariable = program_text, justify='center',
                       font=('Courier',12), bg='black', fg='cyan')
t_program_text.place(x=105, y=300)

#play state label
l_playstate = Label(win, textvariable = state_text, justify='left',
                  font=('Courier',18, 'bold'), bg='black', fg='red')
l_playstate.place(x=333, y=225)

#timer button label
timer_img = PhotoImage(file="analog-clock1-small.png")
l_timer_img = Button(win, image = timer_img, bg='black', activebackground = 'black',
                     borderwidth=0 , highlightthickness= 0, command = sleep_timer)
l_timer_img.place(x=707, y=345)

#timer static label
l_timer_static = Label(win, text='SLEEP', bg='black', fg='snow3', font=('Courier',14, 'bold'))
l_timer_static.place(x=715, y=425)

#timer countdown label
l_timer_countdown = Label(win, textvariable = count_down, bg='black', fg='snow3', font=('Courier',16, 'bold'))
l_timer_countdown.place(x=711, y=450)

#brightness image button, click to put into screnn saver mode
brightness_img=PhotoImage(file='brightness_small.png')
l_brightness = Button(win, image=brightness_img, bg='black', activebackground = 'black',relief='raised',
                      borderwidth=0 , highlightthickness= 0, command = screen_sleep)
l_brightness.place(x=30, y=350)

#brightness static label
l_brightness_static = Label(win, text='SCREEN', bg='black', fg='snow3', font=('Courier',14, 'bold'), )
l_brightness_static.place(x=33, y=430)

#network status label
l_network_status = Label(win, text= 'test ', bg='black', fg='snow3', justify='center', font=('Courier',12))
l_network_status.place(x=140, y=435)

'''
**************************

control buttons

**************************
'''

#'prev' button
prev_img=PhotoImage(file="Prev.png")
b_prev = Button(win, height=90,width=60, justify='center', image=prev_img,text='PREV', relief='raised',
                compound=TOP, font=('Courier',16,'bold'),bg='gold',fg='black', activebackground = 'gold',command=click_prev)
b_prev.place(x=40,y=120)
#'next' button
next_img=PhotoImage(file="Next.png")
b_next = Button(win, height=90,width=60, justify='center', image=next_img,text='NEXT', relief='raised',
                compound=TOP, font=('Courier',16,'bold'),bg='gold',fg='black', activebackground = 'gold',command=click_next)
b_next.place(x=130,y=120)

#'divider' frame inbetween control clusters
f_control_div1=Frame(win,width=7,height=100,bg='black',relief='raised',borderwidth=4)
f_control_div1.place(x=230,y=122)


#'play' button
play_img=PhotoImage(file="Play.png")
b_play = Button(win, height=90,width=60, justify='center', image=play_img,text='PLAY', relief='raised',
                compound=TOP, font=('Courier',16,'bold'),bg='gold',fg='black', activebackground = 'gold',command=click_play)
b_play.place(x=250,y=120)

#'pause' button
pause_img=PhotoImage(file="Pause.png")
b_pause = Button(win, height=90,width=60, justify='center', image=pause_img,text='PAUSE', relief='raised',
                compound=TOP, font=('Courier',16,'bold'),bg='gold',fg='black', activebackground = 'gold',command=click_pause)
b_pause.place(x=340,y=120)

#'stop' button
stop_img=PhotoImage(file="Stop.png")
b_stop = Button(win, height=90,width=60, justify='center', image=stop_img,text='STOP', relief='raised',
                compound=TOP, font=('Courier',16,'bold'),bg='gold',fg='black',activebackground = 'gold', command=click_stop)
b_stop.place(x=430,y=120)

#'divider' frame inbetween control clusters
f_control_div2=Frame(win,width=7,height=100,bg='black',relief='raised',borderwidth=4)
f_control_div2.place(x=530,y=122)

#'mute' button
#mute_img=PhotoImage(file="Mute.png")
b_mute = Button(win, height=90,width=60, justify='center', image=mute_img, text = 'MUTE', relief='raised',
                compound=TOP, font=('Courier',16,'bold'),bg='gold',fg='black',activebackground = 'gold', command=click_mute)
b_mute.place(x=550,y=120)

#'divider' frame inbetween control clusters
f_control_div2=Frame(win,width=7,height=100,bg='black',relief='raised',borderwidth=4)
f_control_div2.place(x=650,y=122)

#'exit' button
exit_img=PhotoImage(file="Exit.png")
b_exit = Button(win, height=90,width=60, justify='center', image=exit_img,text='EXIT', relief='raised',
                compound=TOP, font=('Courier',16,'bold'),bg='firebrick4',fg='snow3', activeforeground = 'snow3',
                activebackground = 'firebrick4', command=click_exit)
b_exit.place(x=670,y=120)

'''
*********************************************************
*
* Setup volume scale (slider)
*
*********************************************************
'''
#speaker image file for 'low' volume
vol_pic1=PhotoImage(file="Speaker-low.png")
l_vol_pic1 = Label(win, image=vol_pic1, bg='black')
l_vol_pic1.place(x=115, y=350)

#speaker image file for 'high' volume
vol_pic2=PhotoImage(file="Speaker-high.png")
l_vol_pic2 = Label(win, image=vol_pic2, bg='black')
l_vol_pic2.place(x=615, y=350)

#volume scale (slider) control
s_volume = Scale(win, from_ =0, to=100, orient = HORIZONTAL, length = 450, width = 40, fg = 'gold',
                 bg = 'black', font=('Courier',16,'bold'), relief = 'raised', borderwidth = 0,
                 troughcolor = 'gold', variable = slider_vol, highlightthickness= 0, command = change_vol)
s_volume.place(x=175, y=340)

'''
*********************************************************
*
* Start script here
*
*********************************************************
'''

# Set window Fullscreenand remove 'fluff' like title bar and tool bar
# to restore windowed app, comment out lines below
win.attributes("-fullscreen", True)
# End Fullscreen set up

# below for fullscreen use with 7 inch LCD touch sceen, comment out for monitor/mouse use
# win.configure(cursor='none')
# End 'No Cursor"

# Some last minute settings before running in the main loop

state_text.set('STOPPED') #always start as STOPPED

update_all_now() #get all the current MPC info and populate GUI

disp_time() #get current time/date

get_stored_vol() #get the save volume form MPD

win.bind_all("<Key>", key) # bind keyboard event to window

win.mainloop() # Loop script for 'events", ex. button clicks and text filed changed
'''
After the 'mainloop' starts, it's now event driven               
'''
